/* Generated by SharpKit 5 v5.4.4 */

if (typeof(JsTypes) == "undefined")
    var JsTypes = [];
var Webprofusion$Scalex$Rendering$WebCanvas = {
    fullname: "Webprofusion.Scalex.Rendering.WebCanvas",
    baseTypeName: "System.Object",
    staticDefinition: {
        cctor: function (){
        }
    },
    assemblyName: "Webprofusion.Scalex",
    interfaceNames: ["Webprofusion.Scalex.Rendering.IGenericDrawingSurface"],
    Kind: "Class",
    definition: {
        ctor: function (containerID, width, height, initialScale){
            this._containerid = null;
            this._width = 0;
            this._height = 0;
            this.canvas = null;
            this.ctx = null;
            this.xscale = 2.2;
            this.yscale = 2.2;
            this.fontScale = 2.2;
            this.defaultFontSize = 6;
            this.defaultFontFamily = "Arial";
            this.enableLogging = true;
            this._ColorPresets = null;
            System.Object.ctor.call(this);
            this.xscale = initialScale;
            this.yscale = initialScale;
            this.fontScale = initialScale;
            this._containerid = containerID;
            this._width = (this.xscale * width);
            this._height = (this.yscale * height);
            this.canvas = document.createElement('canvas');
            this.canvas.width = this._width;
            this.canvas.height = this._height;
            document.getElementById(containerID).appendChild(this.canvas);
            this.ctx = this.canvas.getContext("2d");
        },
        ColorPresets$$: "System.String[]",
        get_ColorPresets: function (){
            return this._ColorPresets;
        },
        set_ColorPresets: function (value){
            this._ColorPresets = value;
        },
        LogEvent: function (msg){
            if (this.enableLogging && console != null)
                console.log(msg);
        },
        Initialise: function (){
            this.set_ColorPresets(["#f0f0f0", "#ffffff", "#606060", "#f0f0f0", "#668cea", "#3B0B0B", "#000000"]);
        },
        SetScale: function (scale){
            this.xscale = scale;
            this.yscale = scale;
            this.fontScale = scale;
        },
        ColorFromPreset: function (presetVal){
            return this.get_ColorPresets()[presetVal];
        },
        ShowColorLegend: function (){
            this.DrawString$$Double$$Double$$String$$ColorPreset(20, 90, "Foreground", Webprofusion.Scalex.Rendering.ColorPreset.Foreground);
            this.DrawString$$Double$$Double$$String$$ColorPreset(60, 90, "ForegroundText", Webprofusion.Scalex.Rendering.ColorPreset.ForegroundText);
            this.DrawString$$Double$$Double$$String$$ColorPreset(110, 90, "MutedForeground", Webprofusion.Scalex.Rendering.ColorPreset.MutedForeground);
            this.DrawString$$Double$$Double$$String$$ColorPreset(150, 90, "Subtle", Webprofusion.Scalex.Rendering.ColorPreset.Subtle);
            this.DrawString$$Double$$Double$$String$$ColorPreset(180, 90, "Accent", Webprofusion.Scalex.Rendering.ColorPreset.Accent);
            this.DrawString$$Double$$Double$$String$$ColorPreset(230, 90, "MutedBackground", Webprofusion.Scalex.Rendering.ColorPreset.MutedBackground);
            this.DrawString$$Double$$Double$$String$$ColorPreset(250, 90, "Background", Webprofusion.Scalex.Rendering.ColorPreset.Background);
        },
        DrawText: function (x, y, text){
            var metrics = this.ctx.measureText("G");
            this.ctx.fillText(text, x, y + metrics.width);
        },
        DrawString$$Double$$Double$$String: function (x, y, text){
            x = x * this.xscale;
            y = y * this.yscale;
            this.ctx.fillStyle = this.ColorFromPreset(Webprofusion.Scalex.Rendering.ColorPreset.ForegroundText);
            this.ctx.font = (this.defaultFontSize * this.fontScale) + "px " + this.defaultFontFamily;
            this.DrawText(x, y, text);
        },
        DrawString$$Double$$Double$$String$$ColorPreset: function (x, y, text, color){
            x = x * this.xscale;
            y = y * this.yscale;
            this.ctx.fillStyle = this.ColorFromPreset(color);
            this.ctx.font = (this.defaultFontSize * this.fontScale) + "px " + this.defaultFontFamily;
            this.DrawText(x, y, text);
        },
        DrawString$$Double$$Double$$String$$Double$$ColorPreset: function (x, y, text, fontSize, color){
            x = x * this.xscale;
            y = y * this.yscale;
            this.ctx.fillStyle = this.ColorFromPreset(color);
            this.ctx.font = (fontSize * this.fontScale) + "px " + this.defaultFontFamily;
            this.DrawText(x, y, text);
        },
        DrawString$$Double$$Double$$String$$Double: function (x, y, text, fontSize){
            this.DrawString$$Double$$Double$$String$$Double$$ColorPreset(x, y, text, fontSize, Webprofusion.Scalex.Rendering.ColorPreset.ForegroundText);
        },
        DrawStringCentered: function (y, text, canvasWidth, fontSize){
        },
        DrawLine: function (x1, y1, x2, y2, strokeThickness, color){
            x1 = x1 * this.xscale;
            y1 = y1 * this.yscale;
            x2 = x2 * this.xscale;
            y2 = y2 * this.yscale;
            this.ctx.strokeStyle = this.ColorFromPreset(color);
            this.ctx.beginPath();
            this.ctx.moveTo(x1, y1);
            this.ctx.lineTo(x2, y2);
            this.ctx.lineWidth = strokeThickness;
            this.ctx.closePath();
            this.ctx.stroke();
        },
        DrawArc: function (x, y, width, isArcDown){
        },
        FillRectangle: function (x1, y1, w, h, FillColor, BorderColor){
            x1 = x1 * this.xscale;
            y1 = y1 * this.yscale;
            w = w * this.yscale;
            h = h * this.xscale;
            this.ctx.fillStyle = this.ColorFromPreset(FillColor);
            this.ctx.fillRect(x1, y1, w, h);
        },
        FillCircle: function (x, y, r){
            this.ctx.beginPath();
            this.ctx.arc(x + r, y + r, r, 0, 2 * Math.PI, false);
            this.ctx.closePath();
            this.ctx.fill();
            this.ctx.stroke();
        },
        FillEllipse$$Double$$Double$$Double$$Double$$ColorPreset$$ColorPreset: function (x1, y1, w, h, FillColor, BorderColor){
            x1 = x1 * this.xscale;
            y1 = y1 * this.yscale;
            w = w * this.yscale;
            h = h * this.xscale;
            var radius = w / 2;
            this.ctx.fillStyle = this.ColorFromPreset(FillColor);
            this.ctx.strokeStyle = this.ColorFromPreset(BorderColor);
            this.FillCircle(x1, y1, radius);
        },
        FillEllipse$$Double$$Double$$Double$$Double$$ColorPreset$$ColorValue: function (x1, y1, w, h, FillColor, BorderColor){
            x1 = x1 * this.xscale;
            y1 = y1 * this.yscale;
            w = w * this.yscale;
            h = h * this.xscale;
            var radius = w / 2;
            this.ctx.fillStyle = this.ColorFromPreset(FillColor);
            this.ctx.strokeStyle = BorderColor.AsRGBAString();
            this.FillCircle(x1, y1, radius);
        },
        FillEllipse$$Double$$Double$$Double$$Double$$ColorValue$$ColorValue: function (x1, y1, w, h, FillColor, BorderColor){
            x1 = x1 * this.xscale;
            y1 = y1 * this.yscale;
            w = w * this.yscale;
            h = h * this.xscale;
            var radius = w / 2;
            this.ctx.fillStyle = FillColor.AsRGBAString();
            this.ctx.strokeStyle = BorderColor.AsRGBAString();
            this.FillCircle(x1, y1, radius);
        },
        Clear: function (){
            this.ctx.clearRect(0, 0, this._width, this._height);
        }
    }
};
JsTypes.push(Webprofusion$Scalex$Rendering$WebCanvas);

